//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
  for (int i = 0; i < 100; i++) color[i] = clBlack;
  color[2] = clRed;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ListBox1MouseDown(TObject *Sender, TMouseButton Button,
  TShiftState Shift, int X, int Y)
{
  if (Button != mbLeft)
    return ;
  TListBox *listbox = (TListBox *) Sender ;
  // Make sure we are actually on an item on the list.
  if (listbox->ItemAtPos (Point (X, Y), true) >= 0)
    listbox->BeginDrag (false,0) ;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ListBox1DragOver(TObject *Sender, TObject *Source,
  int X, int Y, TDragState State, bool &Accept)
{
  // We can only accept drops from the list boxes.
  if (Source == ListBox1 || Source == ListBox2)
    Accept = true ;
  else
    Accept = false ;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ListBox1DragDrop(TObject *Sender, TObject *Source,
  int X, int Y)
{
  // If we are dropping an item where it came from then do nothing.
  if (Sender == Source)
    return ;
  TListBox *sender = (TListBox *) Sender ;
  TListBox *source = (TListBox *) Source ;
  // Move the item from one list to the other.
  sender->Items->Add (source->Items->Strings [source->ItemIndex]) ;
  source->Items->Delete (source->ItemIndex) ;

}
//---------------------------------------------------------------------------
void __fastcall TForm1::ListBox1DrawItem(TWinControl *Control, int Index,
      TRect &Rect, TOwnerDrawState State)
{
  TCanvas *pCanvas = ((TListBox *)Control)->Canvas;
  pCanvas->Font->Color =  color[Index];
  pCanvas->TextOut(Rect.Left, Rect.Top, ((TListBox *)Control)->Items->Strings[Index]);
}
//---------------------------------------------------------------------------
